// #define USE_GRAY_PATCH
// #define USE_LONGMUL_PATCH
// #define USE_LONGDIV_PATCH
   #define USE_INITS_PATCH
   
//#define SAVE_SCREEN

#include <nostub.h>             
#include <all.h>              

int _ti89;

#define STYLE_PUT 1
#define STYLE_XOR 2

#define ARROWS_ROW 0xfffe
#define ENTER_ROW 0xfffd
#define PLUS_KEY 2
#define MINUS_KEY 4
#define LEFT_KEY 2
#define RIGHT_KEY 8
#define UP_KEY 1
#define DOWN_KEY 4
#define SECOND_KEY 16
#define ALPHA_KEY 128
#define ESC_ROW 0xffbf
#define ESC_KEY 1

#define MaxTiles 17

#define scr_rect &(SCR_RECT){0,0,159,99}
#define board(x) ((x)*8)+1
#define index(x,y) ((y)*13)+x

void PutSprite(int x, int y, int sx, int sy, char *sprite,void * buff,int style);
void Draw_Board(void * buff);
void Draw_Switch_Level(void * buff, char flag);
void Game_Loop(void * backb);
void Draw_Title(void * backb);
int choose_tile(void * backb);

	char *lbuff=NULL,* varptr=NULL;
	HANDLE handle={0};
	int line=10;

	int MAXLEVELS=0,lvlsfinished=0;
	int level=0;

    char guysprite1[] = {0x3c,0x3c,0x18,0x7e,0x18,0x3c,0x66,0x00};
	char keyoutline[] = {0x70,0x88,0x88,0x88,0x50,0x50,0x50,0x5e, 
						0x42,0x5e,0x30,0x00,0x00,0x00,0x00,0x00};
	char sprites[MaxTiles][8] = {
	{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff},		//0 floor					
	{0x42,0x7e,0x42,0x7e,0x42,0x7e,0x42,0xff},		//1 Ladder
	{0x81,0x02,0x04,0x08,0x10,0x20,0x40,0xff},		//2 right part of left-dropping slide with floor
	{0x00,0x01,0x02,0x04,0x08,0x10,0x20,0xff},		//3 left part of left-dropping slide with floor
	{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},		//4 nothing!
	{0x00,0x10,0x28,0x10,0x18,0x10,0x18,0xff},		//5 key with floor
	{0x00,0x10,0x28,0x10,0x18,0x10,0x18,0x00},		//6 key without floor
	{0x42,0x66,0x42,0x62,0x42,0x46,0x42,0xff},		//7 Broken Ladder
	{0x43,0x7f,0x42,0x7e,0x42,0x7e,0x42,0xff},		//8 Ladder that breaks after using it
	{0x00,0x01,0x02,0x04,0x08,0x10,0x20,0x00},		//9 left part of left-dropping slide without floor
	{0x00,0x80,0x40,0x20,0x10,0x08,0x04,0x00},		//10 right part of right-dropping slide without floor
	{0x81,0x40,0x20,0x10,0x08,0x04,0x02,0xff},		//11 left part of right-dropping slide with floor
	{0x00,0x80,0x40,0x20,0x10,0x08,0x04,0xff},		//12 right part of right-dropping slide with floor
	{0x00,0x00,0x00,0x00,0x00,0x00,0x29,0xe6}, 	//13 breaking floor
	{0x01,0x07,0x04,0x1c,0x10,0x70,0x40,0xff},		//14 right stairs
	{0x80,0xe0,0x30,0x38,0x08,0x0e,0x02,0xff},		//15 left stairs
	{0x81,0x81,0x81,0x81,0x81,0x81,0x81,0x81}		//16 stright slide
															};

void Game_Loop(void * backb)
{
	int key=0;
	char*temp;
	char test=0;
	static int px=0,py=0,tilstor=0;

	while(key!=264)
	{
		ScrRectFill (&(SCR_RECT){0, 0, 104, 99},  scr_rect, A_REVERSE); 
		Draw_Board(backb);
		DrawClipRect (MakeWinRect(px*8, py*8, px*8+9, py*8+9), scr_rect, A_NORMAL); 
		printf_xy (106, 70, "LVL %i/%i ", level+1,MAXLEVELS);
		LCD_restore(backb);
		key=ngetchx();

		if(key==344 && px<12)
			px++;
		else if(key ==338 && px>0)
			px--;
		else if(key==337 && py>0)
			py--;
		else if(key==340 && py<11)
			py++;
		else if(key==268)
		{
			tilstor=choose_tile(backb);
			lbuff[index(px,py)+level*12*13]=tilstor;
		}
		else if(key==269)
			lbuff[index(px,py)+level*12*13]=tilstor;
		else if(key==270)
		{
			PortSet ((void *)0x4c00, 239, 127);
			test=DlgMessage ("Erase Level", "Are You Sure?", BT_CANCEL, BT_OK);
			PortSet (backb, 239, 127);
			if(test==13)
			{
				memset(lbuff+12*13*level,4,11*13);
				memset(lbuff+(12*13*level)+(11*13),0,13);
			}
		}
		else if(key==271 && level!=0)
		{
		  if((temp=malloc(12*13))==NULL)
		  {
		  	printf_xy(20,30,"Not Enough Memory!");
				LCD_restore(backb);
				ngetchx();
		  }
		  memcpy(temp,lbuff+12*13*level,12*13);
		  memcpy(lbuff+12*13*level,lbuff+12*13*(level-1),12*13);
		  level--;
		  memcpy(lbuff+12*13*level,temp,12*13);
		  free(temp);
		  
		}
		else if(key==272 && level!=MAXLEVELS-1)
		{
			if((temp=malloc(12*13))==NULL)
		  {
		  	printf_xy(20,30,"Not Enough Memory!12");
				LCD_restore(backb);
				ngetchx();
		  }
		  memcpy(temp,lbuff+12*13*level,12*13);
		  memcpy(lbuff+12*13*level,lbuff+12*13*(level+1),12*13);
		  level++;
		  memcpy(lbuff+12*13*level,temp,12*13);
		  free(temp);
		}
		else if(key==43 && level<MAXLEVELS-1)
			level++;
		else if(key==45 && level>0)
			level--;
	}
}

int choose_tile(void * backb)
{
	int key=0,k,ppx,ppy,j;
	static int px=0,py=0,i=0;

	ScrRectFill (&(SCR_RECT){0, 0, 104, 99},  scr_rect, A_REVERSE);
	for (k=0;k<12;k++)
	{
		for(j=0;j<13;j++)
		{
			PutSprite(board(j),board(k),8,8,sprites[index(j,k)],backb,STYLE_XOR);
			if(index(j,k)>MaxTiles-2)
				goto contineu;
		}
	}
contineu:

	ppx=px,ppy=py;
	DrawClipRect (MakeWinRect(ppx*8, ppy*8, ppx*8+9, ppy*8+9), scr_rect, A_XOR); 

	while(key!=264)
	{
		DrawClipRect (MakeWinRect(ppx*8, ppy*8, ppx*8+9, ppy*8+9), scr_rect, A_XOR); 
		DrawClipRect (MakeWinRect(px*8, py*8, px*8+9, py*8+9), scr_rect, A_XOR); 
		LCD_restore(backb);
		key=ngetchx();
		ppx=px,ppy=py;

		if(key==344 && px<12 && i<MaxTiles-1)//right
			px++,i++;
		else if(key ==338 && px>0 && i>0)//left
			px--,i--;
		else if(key==337 && py>0 && i-13>=0)//up
			py--,i-=13;
		else if(key==340 && py<11 && i+13<=MaxTiles-1)//down
			py++,i+=13;
		else
			return i;
	}
}

void _main()
{
	int key=0,pos=0;
	LCD_BUFFER buffer, backb;
	unsigned int l,m=6,n;
	char * VarPtr,*VarPtr2;
	HANDLE temph;

	int i,j=0,k;

	SYM_ENTRY *SymPtr;
	int varsize,type;
  
	SymPtr = SymFindFirst (NULL,6);
	while (SymPtr)
	   {
			varptr = (char*)HeapDeref(SymPtr->handle);
			varsize = (((unsigned char)varptr[0])*256+((unsigned char)varptr[1]))+2;
			MAXLEVELS = varptr[4];
			lvlsfinished = varptr[5];
			type = (((unsigned char)varptr[varsize-2])*256+((unsigned char)varptr[varsize-1]));
			if (type==45 && varptr[3]==111)
				break;
			SymPtr = SymFindNext ();
	   } 
	if(!SymPtr)
	{
		ST_helpMsg ("Cannot Find Janitor Joe Levelset!");
		return;
	}
	
	LCD_save (buffer);
	OSInitKeyInitDelay (75);
	PortSet (backb, 239, 127);

	varptr+=5;

	if((handle=HeapAlloc (MAXLEVELS*13*12))==H_NULL)
			{
				printf_xy(20,30,"Not Enough Memory!1");
				LCD_restore(backb);
				ngetchx();
			}
		lbuff=HeapDeref (handle); 


	for(k=0;k<MAXLEVELS+1;k++)
	{
		while(j<12*13*MAXLEVELS)
		{
			varptr++;
			if((i=(unsigned char)*varptr)>50)
			{
				varptr++;
				for(i-=50;i>0;i--)
					lbuff[j++]=*varptr;
			}
			else
				lbuff[j++]=*varptr;
		}
	}

	Draw_Title(backb);
	Draw_Switch_Level(backb,0);
	FontSetSys (F_6x8);

	while(key!=264)
	{
		switch(key)
		{
		case 337://up
			PutSprite (32,40+pos*10,8,8,guysprite1,backb,STYLE_XOR);
			pos--;
			if(pos<0)
				pos=2;
			PutSprite (32,40+pos*10,8,8,guysprite1,backb,STYLE_PUT);
			break;

		case 340://down
			PutSprite (32,40+pos*10,8,8,guysprite1,backb,STYLE_XOR);
			pos++;
			if (pos>2)
				pos=0;
			PutSprite (32,40+pos*10,8,8,guysprite1,backb,STYLE_PUT);
			break;
			
		case 344://right
			if(pos==1)
			{
				lvlsfinished++;
				if(lvlsfinished>MAXLEVELS)
					lvlsfinished-=MAXLEVELS;
			}
			break;
		
		case 338://left
			if(pos==1)
			{
				lvlsfinished--;
				if(lvlsfinished<1)
					lvlsfinished+=MAXLEVELS;
			}
			break;

		case 13: //enter
				switch(pos)
				{
				case 0:
					Draw_Switch_Level(backb,1);
					Game_Loop(backb);
					Draw_Title(backb);
					Draw_Switch_Level(backb, 0);
					break;
				case 1:
					lvlsfinished++;
					if(lvlsfinished>MAXLEVELS)
						lvlsfinished-=MAXLEVELS;
					break;
				case 2:
					goto endthing;
				}
				break;
		}
		printf_xy (120, 50, "%i/%i  ", lvlsfinished,MAXLEVELS);
		LCD_restore(backb);
		key=ngetchx();
	}
endthing:
OSInitKeyInitDelay (336); 
HeapFree(SymPtr->handle);
	
	if((temph=HeapAlloc(13*12*MAXLEVELS+8))==H_NULL)
			{
				printf_xy(20,30,"Not Enough Memory!2");
				LCD_restore(backb);
				ngetchx();
			}
  VarPtr = HeapDeref(temph);
	for(n=0;n<MAXLEVELS;n++)
	{
			k=115;
			l=0;
		for (i=0;i<12*13+1;i++)
		{
			if(lbuff[n*12*13+i]==k && i!=12*13)
				l++;
			else if(l>0)
			{
				VarPtr[m++]=l+51;
				VarPtr[m++]=lbuff[n*12*13+i-1];
				l=0;
			}
			else if(i!=0)
				VarPtr[m++]=lbuff[n*12*13+i-1];
			k=lbuff[n*12*13+i];
		}
	}
  VarPtr[0] = (unsigned char)(m>>8);
  VarPtr[1] = (unsigned char)m;
	VarPtr[2] = 0;    
	VarPtr[3] = 111;
	VarPtr[4] = MAXLEVELS;
	VarPtr[5] = lvlsfinished;
	VarPtr[m++] = 0;   
	VarPtr[m++] = 0x2D;
	HeapFree(handle);
	if((SymPtr->handle = HeapAlloc(m))==H_NULL)
			{
				printf_xy(20,30,"Not Enough Memory!3");
				LCD_restore(backb);
				ngetchx();
			}
	VarPtr2 = (char*)HeapDeref (SymPtr->handle);
	memcpy (VarPtr2, VarPtr, m); 
	HeapFree(temph);
	Draw_Switch_Level(buffer, 0);
exit:

	PortRestore (); 
}

void Draw_Title(void * backb)
{
	ClrScr();
	FontSetSys (F_8x10);
	DrawStrXY (40, 14, "Janitor Joe", A_SHADED); 
	DrawStrXY (36, 10, "Janitor Joe", A_NORMAL); 
	DrawStrXY (36, 79, "Level Editor", A_SHADED); 
	DrawStrXY (32, 75, "Level Editor", A_NORMAL); 
	PutSprite (20,26,8,16,keyoutline,backb,STYLE_PUT);
	PutSprite (132,26,8,16,keyoutline,backb,STYLE_PUT);
	PutSprite (32,40,8,8,guysprite1,backb,STYLE_PUT);
	FontSetSys (F_4x6);
	DrawStrXY (52, 26, "By Dave Watson", A_NORMAL); 
	FontSetSys (F_6x8);
	DrawStrXY (42, 40, "Edit Levelset", A_NORMAL); 
	DrawStrXY (42, 50, "# Of Levels:", A_NORMAL);
	printf_xy (120, 50, "%i/%i  ", lvlsfinished,MAXLEVELS);
	DrawStrXY (42, 60, "Quit", A_NORMAL);
}

void Draw_Switch_Level(void * buff, char flag)
{
	int i;

	OSFreeTimer(6);
    OSRegisterTimer(6,1);

	if(flag)
	{
		ClrScr();
		Draw_Board(buff);
		FontSetSys (F_4x6);
		DrawStrXY (106, 0, "+:Next Level", A_NORMAL);
		DrawStrXY (106, 10, "-:Prev Level", A_NORMAL);
		DrawStrXY (106, 20, "F1:Change Tile", A_NORMAL);
		DrawStrXY (106, 30, "F2:LstCng Tile", A_NORMAL);
		DrawStrXY (106, 40, "F3:Clear Lvl", A_NORMAL);
		DrawStrXY (106, 50, "F4:Move Fwd", A_NORMAL);
		DrawStrXY (106, 60, "F5:Move Back", A_NORMAL);
	}
	PortSet ((void *)0x4c00, 239, 127);	
	poke(0x600017,0xFA);
	for(i=0;i<100;i++)
	{
		DrawLine (0, i, 159, i, A_NORMAL); 
		while(!OSTimerExpired(6));
		OSTimerRestart(6);
	}

	for(i=100;i>=0;i--)
	{
		memcpy((void *)0x4c00+30*i,buff+30*i,30);
		while(!OSTimerExpired(6));
			OSTimerRestart(6);
	}
	poke(0x600017,0xB2);
	PortSet (buff, 239, 127);
}

void Draw_Board(void * buff)
{
	int i,j;

	for (i=0;i<12;i++)
	{
		for(j=0;j<13;j++)
			PutSprite(board(j),board(i),8,8,sprites[lbuff[index(j,i)+level*12*13]],buff,STYLE_XOR);

	}
	DrawClipRect (&(WIN_RECT){0,0,(13*8)+1,(12*8)+1},&(SCR_RECT){0, 0, 13*8+1, 12*8},A_NORMAL); 
}

void PutSprite(int x, int y, int sx, int sy, char *sprite,void * buff,int style)
{
	register long addr=(long)buff+30*y+((x>>3)&0xfffe),data;
  register int i,cnt=16-(x&15);
  for(i=0;i<sy;i++,addr+=30)
  {
    data=((long)(unsigned)((int)(unsigned)sprite[i]<<8)<<cnt);
	switch(style)
	{
	case STYLE_PUT:
		{
			*(long*)addr|=data;
			break;
		}
	case STYLE_XOR:
		{
			*(long*)addr^=data;
			break;
		}
	}
    
  }
}
