// #define USE_GRAY_PATCH
// #define USE_LONGMUL_PATCH
// #define USE_LONGDIV_PATCH
   #define USE_INITS_PATCH

#include <nostub.h>             
#include <all.h>              

int _ti89;

#define STYLE_PUT 1
#define STYLE_XOR 2

#define ARROWS_ROW 0xfffe
#define LEFT_KEY 2
#define RIGHT_KEY 8
#define UP_KEY 1
#define DOWN_KEY 4
#define SECOND_KEY 16
#define ALPHA_KEY 128
#define ESC_ROW 0xffbf
#define ESC_KEY 1

#define scr_rect &(SCR_RECT){0,0,159,99}
#define board(x) ((x)*8)+1
#define index(x,y) ((y)*13)+x

void PutSprite(int x, int y, int sx, int sy, char *sprite,void * buff,int style);
void invert_scr(int x);
void Draw_Board(void * buff);
void Draw_Switch_Level(void * buff, char flag);
void Game_Loop(void * backb);
void Draw_Title(void * backb);
void High_Scores(void * backb, int score);
void Draw_HS(void * backb,char gonogo);

	char *lbuff=NULL,* varptr=NULL,* newvar=NULL;

	int lvlsfinished=0;
	int highscores[3]={10815,5000,2500};
	char initials[3][9]={"Dave", "Hitoshi","Zeljko"};

    char guysprite1[] = {0x3c,0x3c,0x18,0x7e,0x18,0x3c,0x66,0x00};
	char guyspritedead[] = {0x00,0x00,0x00,0x80,0x18,0x5a,0x3c,0x00};
	char keyoutline[] = {0x70,0x88,0x88,0x88,0x50,0x50,0x50,0x5e, 
						0x42,0x5e,0x30,0x00,0x00,0x00,0x00,0x00};
	char keyinline[] =  {0x00,0x70,0x70,0x70,0x20,0x20,0x20,0x20, 
						0x3c,0x20,0x00,0x00,0x00,0x00,0x00,0x00};
	char sprites[17][8] = {
	{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff},		//0 floor					
	{0x42,0x7e,0x42,0x7e,0x42,0x7e,0x42,0xff},		//1 Ladder
	{0x81,0x02,0x04,0x08,0x10,0x20,0x40,0xff},		//2 right part of left-dropping slide with floor
	{0x00,0x01,0x02,0x04,0x08,0x10,0x20,0xff},		//3 left part of left-dropping slide with floor
	{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},		//4 nothing!
	{0x00,0x10,0x28,0x10,0x18,0x10,0x18,0xff},		//5 key with floor
	{0x00,0x10,0x28,0x10,0x18,0x10,0x18,0x00},		//6 key without floor
	{0x42,0x66,0x42,0x62,0x42,0x46,0x42,0xff},		//7 Broken Ladder
	{0x42,0x7e,0x42,0x7e,0x42,0x7e,0x42,0xff},		//8 Ladder that breaks after using it
	{0x00,0x01,0x02,0x04,0x08,0x10,0x20,0x00},		//9 left part of left-dropping slide without floor
	{0x00,0x80,0x40,0x20,0x10,0x08,0x04,0x00},		//10 right part of right-dropping slide without floor
	{0x81,0x40,0x20,0x10,0x08,0x04,0x02,0xff},		//11 left part of right-dropping slide with floor
	{0x00,0x80,0x40,0x20,0x10,0x08,0x04,0xff},		//12 right part of right-dropping slide with floor
	{0x00,0x00,0x00,0x00,0x00,0x00,0x20,0xee},		//13 breaking floor
	{0x01,0x07,0x04,0x1c,0x10,0x70,0x40,0xff},		//14 right stairs
	{0x80,0xe0,0x30,0x38,0x08,0x0e,0x02,0xff},		//15 left stairs
	{0x81,0x81,0x81,0x81,0x81,0x81,0x81,0x81}		//16 stright slide
															};

	char level=0,lives=5,px=0,py=11,savelevel=0,saveflag=0,savelives=0;
	int savescore=0,score=0;

void Game_Loop(void * backb)
{
	char i,j,oldpx,oldpy,falling,keys,count,mover,test;
	WINDOW w;
	int key;

	level=0,lives=5,score=0;

display:
	px=0,py=11,falling=0,keys=0,count=0,mover=0;
    
    Draw_Board(backb);

	LCD_restore (backb);
	OSSetSR (0x0400); 
	
	if(saveflag)
	{
		if(savelevel!=level)
		{
				level++;
				varptr=newvar;
				score=savescore;
				lives=savelives;
				goto display;
		}
		else
			saveflag=0;
	}

	while(1)
	{
		oldpx=px,oldpy=py;
		
		while(!OSTimerExpired(6));

		count++;
		if(lbuff[index(px,py)] == 4 || lbuff[index(px,py)] == 9 || lbuff[index(px,py)] == 6 || lbuff[index(px,py)] == 10 || lbuff[index(px,py)] == 16 )
		{
			if(falling<15*3)
				falling++;
			else
				goto dying;
			py++;
			if(lbuff[index(px,py)] == 2)
				px--,falling=0;
			else if(lbuff[index(px,py)] == 11)
				px++,falling=0;
			if(py>11)
				py=0;
		}
		else if(falling >=2)
		{		
			PutSprite (board(px),board(py),8,8,guysprite1,backb,STYLE_XOR);
			PutSprite (board(px),board(py),8,8,guyspritedead,backb,STYLE_XOR);
dying:
			LCD_restore (backb);
			lives--;
			invert_scr(8);
			score-=keys*100;
			if (score<0)
				score=0;
			if(lives<0)
			{
				WinOpen (&w, MakeWinRect (75, 0, 159, 33), WF_TTY|WF_ROUNDEDBORDER|WF_TITLE,"Joe's Dead!");
				WinActivate (&w);
				WinFont (&w, F_6x8);
				WinStr (&w, "  You Lose!\nTry Again!!!");
				LCD_restore (backb);
				ngetchx();
				WinClose(&w);
				savelives=5;
				savescore=0;
				savelevel=level;
				if(score>highscores[2])
					{
						Draw_HS(backb,0);
						Draw_Switch_Level(backb,0);
						High_Scores(backb,score);
					}
		  	return;
			}
			goto display;
		}
		else
		{
			falling=0;
			key=ngetchx();
			if(key==264)//esc
			{
				PortSet ((void *)0x4c00, 239, 127);
				test=DlgMessage ("Quit Current Game", "Are You Sure?", BT_CANCEL, BT_OK);
				PortSet (backb, 239, 127);
				if(test==13)
				{
					savelives=lives;
					savelevel=level;
					return;
				}
			}
			else if(lbuff[index(px,py)] == 13)
			{
				lbuff[index(px,py)] = 4;
				PutSprite (board(px),board(py),8,8,sprites[13],backb,STYLE_XOR);
			}
			if((key==344)&&px<12)//right
			{
				if(lbuff[index(px,py)] == 14 && py>0)
					py--;
				px++;
			}
			if((key==338)&&px>0)//left
			{
				if(lbuff[index(px,py)] == 15 && py>0)
					py--;
				px--;
			}
			if((key==337)&&py>0)//up
			{
				if(lbuff[index(px,py)] == 1) py--;
				else if(lbuff[index(px,py)] == 8) 
				{
					lbuff[index(px,py)] = 7;
					PutSprite (board(px),board(py),8,8,sprites[8],backb,STYLE_XOR);
					PutSprite (board(px),board(py),8,8,sprites[7],backb,STYLE_XOR);
					py--;
				}
			}
			if((key==340)&&py<11)//down
			{
				if(lbuff[index(px,py+1)] == 1) py++;
				else if(lbuff[index(px,py+1)] == 8) 
				{
					py++;
					lbuff[index(px,py)] = 7;
					PutSprite (board(px),board(py),8,8,sprites[8],backb,STYLE_XOR);
					PutSprite (board(px),board(py),8,8,sprites[7],backb,STYLE_XOR);
				}
			}
			if(key==273&&level+1<lvlsfinished)//second && F1
			{
				level++;
				varptr=newvar;
				goto display;
			}
		}
		OSTimerRestart(6);
		PutSprite (board(oldpx),board(oldpy),8,8,guysprite1,backb,STYLE_XOR);
		PutSprite (board(px),board(py),8,8,guysprite1,backb,STYLE_XOR);
		LCD_restore (backb);
		if(lbuff[index(px,py)]==5 || lbuff[index(px,py)]==6)
		{
		
			PutSprite (board(px),board(py),8,8,sprites[6],backb,STYLE_XOR);
			if(lbuff[index(px,py)]==6)
				lbuff[index(px,py)]=4;
			else
				lbuff[index(px,py)]=0;
			PutSprite(109+(10*keys),47,8,16,keyinline,backb,STYLE_PUT);
			LCD_restore (backb);
			keys++;
			if (count > 85)
				count = 85;
			score+=(100-count);
			count=0;
			printf_xy(112,79,"%i",score);
			LCD_restore (backb);
			if(keys==5)
			{
				level++;
				varptr=newvar;
				savescore=score;
				if (level+1>lvlsfinished)
				{
					WinOpen (&w, MakeWinRect (75, 0, 159, 33), WF_TTY|WF_ROUNDEDBORDER|WF_TITLE,"You Win!");
					WinActivate (&w);
					WinFont (&w, F_6x8);
					WinStr (&w, "   You Win!\n  Way to go!");
					LCD_restore (backb);
					ngetchx();
					WinClose(&w);
					if(score>highscores[2])
					{
						Draw_HS(backb,0);
						Draw_Switch_Level(backb,0);
						High_Scores(backb,score);
					}
					return;
				}
				Draw_Switch_Level(backb, 1);
				goto display;
			}
		}
	}
}

void _main()
{
	int key=0,pos=0;
	char *temp;
	LCD_BUFFER buffer, backb;

	SYM_ENTRY *SymPtr;
	int varsize,type;
  
	SymPtr = SymFindFirst (NULL,6);
	while (SymPtr)
	   {
			varptr = (char*)HeapDeref(SymPtr->handle);
			varsize = (((unsigned char)varptr[0])*256+((unsigned char)varptr[1]))+2;
			lvlsfinished = varptr[5];
			type = (((unsigned char)varptr[varsize-2])*256+((unsigned char)varptr[varsize-1]));
			if (type==45 && varptr[3]==111)
				break;
			SymPtr = SymFindNext ();
	   } 
	if(!SymPtr)
	{
		ST_helpMsg ("Cannot Find Janitor Joe Levelset!");
		return;
	}

	varptr+=5;//skip header of file
	temp=varptr;
	
	LCD_save (buffer);
	PortSet (backb, 239, 127);
	lbuff=malloc(13*12);
	OSInitKeyInitDelay (75);
	
	Draw_Title(backb);
	Draw_Switch_Level(backb,0);

	while(key!=264)
	{
		switch(key)
		{
		case 337:
			PutSprite (32,36+pos*10,8,8,guysprite1,(void *)0x4c00,STYLE_XOR);
			pos--;
			if(pos<0)
				pos=3;
			PutSprite (32,36+pos*10,8,8,guysprite1,(void *)0x4c00,STYLE_PUT);
			break;

		case 340:
			PutSprite (32,36+pos*10,8,8,guysprite1,(void *)0x4c00,STYLE_XOR);
			pos++;
			if (pos>3)
				pos=0;
			PutSprite (32,36+pos*10,8,8,guysprite1,(void *)0x4c00,STYLE_PUT);
			break;

		case 13: //enter
				switch(pos)
				{
				case 0:
					level=0,lives=5,score=0;
					Draw_Switch_Level(backb,1);
					Game_Loop(backb);
					Draw_Title(backb);
					Draw_Switch_Level(backb, 0);
					varptr=temp;
					break;
				case 1://highscores
					Draw_HS(backb,1);
					Draw_Switch_Level(backb,0);
					ngetchx();
					Draw_Title(backb);
					Draw_Switch_Level(backb, 0);
					pos=0;
					break;
				case 2:
					if(savelevel!=0)
					{
						level=0,lives=savelives,score=savescore,saveflag=1;
						Game_Loop(backb);
						Draw_Title(backb);
						Draw_Switch_Level(backb, 0);
						varptr=temp;
						pos=0;
					}
					break;
				case 3:
					goto endthing;
				}
				break;
		}
		key=ngetchx();
	}
endthing:
	OSInitKeyInitDelay (336); 
	free(lbuff);
	Draw_Switch_Level(buffer, 0);

	PortRestore (); 
}

void Draw_Title(void * backb)
{
	ClrScr();
	FontSetSys (F_8x10);
	DrawStrXY (40, 14, "Janitor Joe", A_SHADED); 
	DrawStrXY (36, 10, "Janitor Joe", A_NORMAL); 
	PutSprite (20,26,8,16,keyoutline,backb,STYLE_PUT);
	PutSprite (132,26,8,16,keyoutline,backb,STYLE_PUT);
	PutSprite (32,36,8,8,guysprite1,backb,STYLE_PUT);
	FontSetSys (F_4x6);
	DrawStrXY (52, 26, "By Dave Watson", A_NORMAL); 
	DrawStrXY (42, 76, "-- Special Thanks To --", A_NORMAL); 
	DrawStrXY (42, 84, "Hitoshi Satow: Idea Guy", A_NORMAL);
	DrawStrXY (36, 92, "Zeljko Juric for C Library", A_NORMAL);
	FontSetSys (F_6x8);
	DrawStrXY (42, 36, "Play The Game", A_NORMAL); 
	DrawStrXY (42, 46, "View High Scores", A_NORMAL);
	if(savelevel!=0)
		DrawStrXY (42, 56, "Play Saved Game", A_NORMAL);
	else
		DrawStrXY (42, 56, "Play Saved Game", A_SHADED);
	DrawStrXY (42, 66, "Quit", A_NORMAL);
}

void Draw_Switch_Level(void * buff, char flag)
{
	int i;
	char s[50];

	OSFreeTimer(6);
    OSRegisterTimer(6,1);

	px=0,py=11;
	if(flag)
		Draw_Board(buff);
	PortSet ((void *)0x4c00, 239, 127);	
	poke(0x600017,0xFA);
	for(i=0;i<100;i++)
	{
		DrawLine (0, i, 159, i, A_NORMAL); 
		while(!OSTimerExpired(6));
		OSTimerRestart(6);
	}
	if(flag)
	{
		sprintf (s, "Level: %i",level+1);  
		DrawStrXY (56, 45 ,s, A_REVERSE); 
		ngetchx();
		OSSetSR (0x0400);
	}
	for(i=100;i>=0;i--)
	{
		memcpy((void *)0x4c00+30*i,buff+30*i,30);
		while(!OSTimerExpired(6));
			OSTimerRestart(6);
	}
	poke(0x600017,0xB2);
	PortSet (buff, 239, 127);
}


void invert_scr(int x)
{
  register long *ptr;
  register int i;
  OSTimerRestart(6);
  for(i=0;i<x;i++)
  {
	for(ptr=(long*)0x4c00;(long)ptr<=0x57b8;*ptr++^=-1)
		;
	while(!OSTimerExpired(6));
        OSTimerRestart(6);
  }
}

void Draw_Board(void * buff)
{
	int i,j=0;
	char *temp;

	ClrScr();

	newvar=varptr;

	while(j<12*13)
	{
		varptr++;
		if((i=(unsigned char)*varptr)>50)
		{
			varptr++;
			for(i-=50;i>0;i--)
				lbuff[j++]=*varptr;
		}
		else
			lbuff[j++]=*varptr;
	}
	temp=varptr;
	varptr=newvar;
	newvar=temp;

	for (i=0;i<12;i++)
	{
		for(j=0;j<13;j++)
			PutSprite(board(j),board(i),8,8,sprites[lbuff[index(j,i)]],buff,STYLE_PUT);

	}
	for (i=0;i<5;i++)
	{
		PutSprite(109+(10*i),47,8,16,keyoutline,buff,STYLE_PUT);
	}
	for (i=0;i<lives;i++)
	{
		PutSprite(131+(10*i)-(lives*4),90,8,8,guysprite1,buff,STYLE_PUT);
	}
	DrawClipRect (&(WIN_RECT){0,0,(13*8)+1,(12*8)+1},&(SCR_RECT){0, 0, 13*8+1, 12*8},A_NORMAL); 
	PutSprite (board(px),board(py),8,8,guysprite1,buff,STYLE_XOR);
	FontSetSys (F_8x10); 
	DrawStrXY (112, 10, "Janit", A_SHADED); 
	DrawStrXY (115, 13, "Janit", A_NORMAL); 
	DrawStrXY (120, 27, "Joe", A_SHADED); 
	DrawStrXY (123, 30, "Joe", A_NORMAL); 
	FontSetSys (F_6x8); 
	DrawStrXY (112, 64, "Score:", A_NORMAL); 
	printf_xy(112,79,"%i",score);
}

void PutSprite(int x, int y, int sx, int sy, char *sprite,void * buff,int style)
{
	register long addr=(long)buff+30*y+((x>>3)&0xfffe),data;
  register int i,cnt=16-(x&15);
  for(i=0;i<sy;i++,addr+=30)
  {
    data=((long)(unsigned)((int)(unsigned)sprite[i]<<8)<<cnt);
	switch(style)
	{
	case STYLE_PUT:
		{
			*(long*)addr|=data;
			break;
		}
	case STYLE_XOR:
		{
			*(long*)addr^=data;
			break;
		}
	}
    
  }
}

void High_Scores(void * backb, int score)
{
	char init[9]="        ";
	char done=0,pos=0;
	int key;
	
	FontSetSys (F_4x6);
	DrawStrXY (42, 76, " You Got a High Score!         ", A_NORMAL); 
	DrawStrXY (42, 84, "Please enter your Name         ", A_NORMAL);
	//92
	while(!done)
	{
		printf_xy(60,92,"%s         ",init);
		LCD_restore(backb);
		key=ngetchx();
		if(key==13)
		{
			done=1;
		}
		else if(key==257)
		{
			if(pos>0)
			{
				init[pos-1]=' ';
				pos--;
			}
		}
		else
		{
			if(pos<8)
			{
				init[pos++]=key;
			}
		}
	}
	init[pos]='\0';
	if(score>highscores[0])
	{
		highscores[2]=highscores[1];
		highscores[1]=highscores[0];
		highscores[0]=score;
		strcpy (initials[2], initials[1]);
		strcpy (initials[1], initials[0]);
		strcpy (initials[0], init);
	}
	else if(score>highscores[1])
	{
		highscores[2]=highscores[1];
		highscores[1]=score;
		strcpy (initials[2], initials[1]);
		strcpy (initials[1], init);
	}
	else
	{
		highscores[2]=score;
		strcpy (initials[2], init);
	}
}

void Draw_HS(void * backb,char gonogo)
{
	ClrScr();
	FontSetSys (F_8x10);
	DrawStrXY (40, 14, "High Scores", A_SHADED); 
	DrawStrXY (36, 10, "High Scores", A_NORMAL); 
	PutSprite (20,26,8,16,keyoutline,backb,STYLE_PUT);
	PutSprite (132,26,8,16,keyoutline,backb,STYLE_PUT);
	FontSetSys (F_4x6);
	DrawStrXY (52, 26, " Legends of Joe", A_NORMAL); 
	if(gonogo)
	{
		DrawStrXY (42, 76, "Try to beat the high Score!", A_NORMAL); 
		DrawStrXY (42, 84, "If you can beat me, e-mail", A_NORMAL);
		DrawStrXY (42,92,"Tenordave@hotmail.com !",A_NORMAL);
	}
	FontSetSys (F_6x8);
	printf_xy (55, 40, "%s: %i",initials[0],highscores[0]); 
	printf_xy (55, 50, "%s: %i",initials[1],highscores[1]);
	printf_xy (55, 60, "%s: %i",initials[2],highscores[2]);
}
